unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ComCtrls, OleCtrls, Menus, Types, ExtCtrls, Spin,
  ZylGPSSimulator, Dialogs;

type

  TfrmMain = class(TForm)
    gbLat: TGroupBox;
    btnTransmit: TBitBtn;
    cmbLat: TComboBox;
    lblDegree: TLabel;
    lblMinute: TLabel;
    lblSecond: TLabel;
    gbLong: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cmbLong: TComboBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    efLatDeg: TSpinEdit;
    efLatMin: TSpinEdit;
    efLatSec: TSpinEdit;
    efLongDeg: TSpinEdit;
    efLongMin: TSpinEdit;
    efLongSec: TSpinEdit;
    efHeading: TSpinEdit;
    efSpeed: TSpinEdit;
    efAltitude: TSpinEdit;
    btnTransmitFromFile: TBitBtn;
    efFile: TEdit;
    btnBrowseTitle: TBitBtn;
    OpenDialog: TOpenDialog;
    ZylGPSSimulator: TZylGPSSimulator;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnTransmitClick(Sender: TObject);
    procedure btnTransmitFromFileClick(Sender: TObject);
    procedure btnBrowseTitleClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
 
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cmbLat.ItemIndex := 0;
  cmbLong.ItemIndex := 0;
  ZylGPSSimulator.Open();
end;

procedure TfrmMain.btnTransmitClick(Sender: TObject);
begin
  ZylGPSSimulator.Latitude_Degree := efLatDeg.Value;
  ZylGPSSimulator.Latitude_Minute := efLatMin.Value;
  ZylGPSSimulator.Latitude_Second := efLatSec.Value;
  if cmbLat.Text = 'North' then
    ZylGPSSimulator.Latitude_Direction := cpNorth
  else
    ZylGPSSimulator.Latitude_Direction := cpSouth;
  ZylGPSSimulator.Longitude_Degree := efLongDeg.Value;
  ZylGPSSimulator.Longitude_Minute := efLongMin.Value;
  ZylGPSSimulator.Longitude_Second := efLongSec.Value;
  if cmbLong.Text = 'East' then
    ZylGPSSimulator.Longitude_Direction := cpEast
  else
    ZylGPSSimulator.Longitude_Direction := cpWest;
  ZylGPSSimulator.Altitude := efAltitude.Value;
  ZylGPSSimulator.Heading := efHeading.Value;
  ZylGPSSimulator.Speed := ZylGPSSimulator.KmhToKnots(efSpeed.Value);

  ZylGPSSimulator.Transmit();
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ZylGPSSimulator.Close();
end;

procedure TfrmMain.btnTransmitFromFileClick(Sender: TObject);
begin
  ZylGPSSimulator.TransmitFromFile(efFile.Text, 100);
end;

procedure TfrmMain.btnBrowseTitleClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    if Length(OpenDialog.FileName) > 3 then
    begin
      efFile.Text := OpenDialog.FileName;
    end;
  end;
end;

end.
